package io.skore.smooch_plugin

import android.content.Context
import android.os.Bundle
import android.util.Log
import io.skore.smooch.util.LangPreference
import io.smooch.core.Smooch
import io.smooch.ui.ConversationActivity
import kotlinx.android.synthetic.main.smooch_activity_conversation.*

class SmoochActivity : ConversationActivity() {
    private val TAG = SmoochActivity::class.java.simpleName

    override fun attachBaseContext(baseContext: Context?) {
        super.attachBaseContext(if (baseContext != null) LangPreference.updateResources(baseContext, LangPreference.getLang(baseContext)) else null)
    }

    override fun onCreate(savedInstanceState: Bundle?) {
        super.onCreate(savedInstanceState)

        logSmoochStatus()

        supportActionBar?.setDisplayHomeAsUpEnabled(false)

        back.setOnClickListener {
            onBackPressed()
        }
    }

    private fun logSmoochStatus() {
        val connectionStatus = Smooch.getSmoochConnectionStatus()
        val initStatus = Smooch.getInitializationStatus()
        val loginStatus = Smooch.getLastLoginResult()
        Log.d(TAG, "Smooch status\nConnection: ${connectionStatus?.name ?: "unknown"}\nInit: ${initStatus?.name ?: "unknown"}\nLogin: ${loginStatus?.name ?: "unknown"}")
    }
}