package io.skore.smooch_plugin

import android.app.Activity
import android.app.Application
import android.util.Log
import com.google.firebase.FirebaseApp
import io.flutter.view.FlutterMain
import io.smooch.core.Smooch

class SmoochApplication : Application() {
    private val TAG = SmoochApplication::class.java.simpleName
    private var mCurrentActivity: Activity? = null

    override fun onCreate() {
        super.onCreate()
        Log.d(TAG, "onCreate")

        FlutterMain.startInitialization(this)
        FirebaseApp.initializeApp(this)
        Smooch.init(this)
    }

    fun getCurrentActivity(): Activity? {
        return this.mCurrentActivity
    }

    fun setCurrentActivity(currentActivity: Activity) {
        mCurrentActivity = currentActivity
    }
}